﻿using System;
using System.Diagnostics;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.IO;
using System.Collections.Generic;
using Newtonsoft.Json.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;


class groups
{
    //replace api_key placeholder with your own value
    private static String apiUrl = "https://sandbox.e-signlive.com/api/packages";
    private static String apiKey = "api_key";

    public static void Main(string[] args)
    {
        //JSON string to create a group with members in a single request
        string jsonString = "{ \"email\": \"your_group_email\", \"name\": \"your_group_name\", \"members\": [ { \"pending\": true, \"email\": \"member.email@example.com\", \"memberType\": \"REGULAR\", \"firstName\": \"John\", \"lastName\": \"Doe\" }, { \"pending\": true, \"email\": \"member.email@example.com\", \"memberType\": \"REGULAR\", \"firstName\": \"Mary\", \"lastName\": \"Doe\" } ] }";
        
        //JSON string to create an empty group
        string jsonString1 = "{\"email\": \"esl.group@signer.com\",\"name\": \"REST Developers\"}";

        //JSON strings to invite members to group
        string jsonString2 = "{\"email\": \"esl.signer1@example.com\",\"members\": [{\"pending\": true,\"email\": \"esl.signer1@example.com\",\"memberType\": \"REGULAR\"}]}";
        string jsonString3 = "{\"email\": \"esl.signer2@example.com\",\"members\": [{\"pending\": true,\"email\": \"esl.signer2@example.com\",\"memberType\": \"MANAGER\"}]}";

        //JSON string to apply a group signature
        string jsonString4 = "{ \"role\" : \"cc5d5296-ae92-48ec-a0ee-2a327d8a66b9\", \"fields\":[ { \"top\":680, \"left\":370, \"width\":200, \"height\":50, \"page\":0, \"type\":\"SIGNATURE\", \"value\":null, \"subtype\":\"FULLNAME\" }] }";

        StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

        HttpClient myClient = new HttpClient();
        myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
        myClient.DefaultRequestHeaders.Add("Accept", "application/json");

        //URL to add group approval to document
        var response = myClient.PostAsync(new Uri(apiUrl + "/125f8b8d-f83b-42b0-9915-19ef57504700/documents/0f5e490a1a964efd/approvals"), jsonContent).Result;
        Debug.WriteLine(response.Content.ReadAsStringAsync().Result);

        //URL to retrieve your groups
        var groups = myClient.GetAsync(new Uri("https://sandbox.e-signlive.com/groups")).Result;
        JObject json = JObject.Parse(groups.Content.ReadAsStringAsync().Result);
        Debug.WriteLine(json);

    }
}